## ros-melodic-dccomms-ros 0.0.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.1)
project(dccomms_ros CXX)

SET(DISABLE_GIT_HASH ON CACHE BOOL "Disables git hash suffix on libraries")
SET(class_loader_NAME_OVERRIDE "dccomms_class_loader" CACHE STRING "Override class_loader project name")

#It seams that from Ubuntu 17.10 the linker flag --disable-new-dtags is needed
#for the executable to be able to find absolute linked shared libraries with rpath.
#https://stackoverflow.com/questions/47117443/dynamic-linking-with-rpath-not-working-under-ubuntu-17-10
#SET(CMAKE_EXE_LINKER_FLAGS "-Wl,--disable-new-dtags")

set(CMAKE_VERBOSE_MAKEFILE ON)

SET(MODULES_DIR "modules" )

## Find catkin macros and libraries
## if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
## is used, also find other catkin packages
find_package(catkin REQUIRED COMPONENTS
		roscpp
		rospy
		std_msgs
		actionlib
		actionlib_msgs
		message_generation
                std_srvs
                tf
                dccomms_ros_msgs
)

#http://stackoverflow.com/questions/7787823/cmake-how-to-get-the-name-of-all-subdirectories-of-a-directory
function(GETPROJECTS result curdir)
  FILE(GLOB children RELATIVE ${curdir} ${curdir}/*/CMakeLists.txt)
  SET(dirlist "")
  FOREACH(file ${children})
        get_filename_component(subdir ${file} DIRECTORY)
        LIST(APPEND dirlist ${subdir})
  ENDFOREACH()
  SET(${result} ${dirlist} PARENT_SCOPE)
endfunction()

#BEGIN RESOLVE GIT REVISION
#https://bravenewmethod.com/2017/07/14/git-revision-as-compiler-definition-in-build-with-cmake/
message(STATUS "Resolving GIT Version...")
set(_build_version "unknown")
find_package(Git REQUIRED)
if(GIT_FOUND)
  execute_process(
    COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
    OUTPUT_VARIABLE _build_version
    ERROR_QUIET
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
  message( STATUS "GIT hash: ${_build_version}")
else()
  message(STATUS "GIT not found")
endif()
string(TIMESTAMP _time_stamp)
#END RESOLVE GIT REVISION

#CHECK IF NS3 HAS ALREADY BEEN BUILT
message(STATUS "Check NS3 libraries...")
execute_process (
    COMMAND bash -c "./ns3configured.sh"
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
    OUTPUT_VARIABLE ns3configured
    ERROR_QUIET
    OUTPUT_STRIP_TRAILING_WHITESPACE
)

SET(NS3_BUILD ${CMAKE_CURRENT_SOURCE_DIR}/modules/ns-3-dev/build)
SET(NS3_INCLUDE_PATH ${NS3_BUILD})
SET(NS3_HEADERS_DIR ${NS3_BUILD}/ns3)

message("NS3 build path: ${NS3_BUILD}")
message("NS3 include path: ${NS3_INCLUDE_PATH}")
message("NS3 headers dir: ${NS3_HEADERS_DIR}")
execute_process(
  COMMAND mkdir -p ${NS3_BUILD}
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)

#https://stackoverflow.com/questions/15972898/cmake-how-to-run-a-add-custom-command-before-everything-else
#./waf configure --build-profile=debug --enable-examples --enable-tests --enable-sudo
#./waf build
#SET(WAF_EXECUTABLE ${CMAKE_CURRENT_SOURCE_DIR}/modules/ns-3-dev/waf)
if("${ns3configured}" STREQUAL "true")
    message(STATUS "Build NS3.")
    SET(WAF_EXECUTABLE ./waf)
    execute_process(
      COMMAND ${WAF_EXECUTABLE} build
      WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/modules/ns-3-dev/"
    )
else()
    message(STATUS "Configure and build NS3 in ${NS3_BUILD}")
    SET(WAF_EXECUTABLE ./waf)
    execute_process(
      COMMAND ${WAF_EXECUTABLE} configure --build-profile=debug --enable-examples --enable-tests -o ${NS3_BUILD}#--enable-sudo
      WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/modules/ns-3-dev/"
    )
    execute_process(
      COMMAND ${WAF_EXECUTABLE} build
      WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/modules/ns-3-dev/"
    )
endif()

SET(NS3_LIBS
    ns3-dev-antenna-debug                ns3-dev-flow-monitor-test-debug      ns3-dev-propagation-debug
    ns3-dev-antenna-test-debug           ns3-dev-internet-apps-debug          ns3-dev-propagation-test-debug
    ns3-dev-aodv-debug                   ns3-dev-internet-apps-test-debug     ns3-dev-sixlowpan-debug
    ns3-dev-aodv-test-debug              ns3-dev-internet-debug               ns3-dev-sixlowpan-test-debug
    ns3-dev-applications-debug           ns3-dev-internet-test-debug          ns3-dev-spectrum-debug
    ns3-dev-applications-test-debug      ns3-dev-lr-wpan-debug                ns3-dev-spectrum-test-debug
    ns3-dev-aqua-sim-ng-debug            ns3-dev-lr-wpan-test-debug           ns3-dev-stats-debug
    ns3-dev-aqua-sim-ng-test-debug       ns3-dev-lte-debug                    ns3-dev-stats-test-debug
    ns3-dev-bridge-debug                 ns3-dev-lte-test-debug               ns3-dev-tap-bridge-debug
    ns3-dev-buildings-debug              ns3-dev-mesh-debug                   ns3-dev-test-debug
    ns3-dev-buildings-test-debug         ns3-dev-mesh-test-debug              ns3-dev-test-test-debug
    ns3-dev-config-store-debug           ns3-dev-mobility-debug               ns3-dev-topology-read-debug
    ns3-dev-core-debug                   ns3-dev-mobility-test-debug          ns3-dev-topology-read-test-debug
    ns3-dev-core-test-debug              ns3-dev-mpi-debug                    ns3-dev-traffic-control-debug
    ns3-dev-csma-debug                   ns3-dev-netanim-debug                ns3-dev-traffic-control-test-debug
    ns3-dev-csma-layout-debug            ns3-dev-netanim-test-debug           ns3-dev-uan-debug
    ns3-dev-dsdv-debug                   ns3-dev-network-debug                ns3-dev-uan-test-debug
    ns3-dev-dsdv-test-debug              ns3-dev-network-test-debug           ns3-dev-virtual-net-device-debug
    ns3-dev-dsr-debug                    ns3-dev-nix-vector-routing-debug     ns3-dev-wave-debug
    ns3-dev-dsr-test-debug               ns3-dev-olsr-debug                   ns3-dev-wave-test-debug
    ns3-dev-energy-debug                 ns3-dev-olsr-test-debug              ns3-dev-wifi-debug
    ns3-dev-energy-test-debug            ns3-dev-point-to-point-debug         ns3-dev-wifi-test-debug
    ns3-dev-fd-net-device-debug          ns3-dev-point-to-point-layout-debug  ns3-dev-wimax-debug
    ns3-dev-flow-monitor-debug           ns3-dev-point-to-point-test-debug    ns3-dev-wimax-test-debug
)

#Catkin do not export well relative paths to libraries: https://github.com/ros/catkin/issues/535
#link_directories(${NS3_BUILD})
#So it's better to specify the full path to each .so if the the *.so are not in the common directories (see ldconfig)
message("NS3 modules: ${NS3_LIBS}")
FOREACH(lib ${NS3_LIBS})
	find_library(NS3LIB_${lib} NAMES "${lib}" PATHS "${NS3_BUILD}")
	if(NOT NS3LIB_${lib})
		message(FATAL_ERROR "NS3 LIBRARY ${lib} NOT FOUND")
	else()
		message(STATUS "#####################  NS3 LIBRARY FOUND: ${NS3LIB_${lib}}")
	endif()
ENDFOREACH()


SET(${PROJECT_NAME}_INCLUDE_DIRS
    ${CMAKE_CURRENT_SOURCE_DIR}/src/include
    ${NS3_INCLUDE_PATH}
    ${CMAKE_CURRENT_SOURCE_DIR}/modules/exprtk
    ${CMAKE_CURRENT_SOURCE_DIR}/modules/dccomms_utils/src/lib/include
    ${CMAKE_CURRENT_SOURCE_DIR}/modules/dccomms_utils/modules/dccomms_packets/src/include
    ${CMAKE_CURRENT_SOURCE_DIR}/modules/dccomms_utils/modules/cxxopts/include
    ${CMAKE_CURRENT_SOURCE_DIR}/modules/dccomms_utils/modules/dccomms_packets/modules/dccomms/include
    ${CMAKE_CURRENT_SOURCE_DIR}/modules/dccomms_utils/modules/dccomms_packets/modules/dccomms/deps/cpplogging/includes
    ${CMAKE_CURRENT_SOURCE_DIR}/modules/dccomms_utils/modules/dccomms_packets/modules/dccomms/deps/cpplogging/spdlog/include
    ${CMAKE_CURRENT_SOURCE_DIR}/modules/dccomms_utils/modules/dccomms_packets/modules/dccomms/deps/cpputils/src/include
    ${CMAKE_CURRENT_SOURCE_DIR}/modules/dccomms_utils/modules/dccomms_packets/modules/dccomms/deps/class_loader/include
    )

###################################
## catkin specific configuration ##
###################################

## The catkin_package macro generates cmake config files for your package
## Declare things to be passed to dependent projects
## INCLUDE_DIRS: uncomment this if you package contains header files
## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need
catkin_package(
  INCLUDE_DIRS ${${PROJECT_NAME}_INCLUDE_DIRS}
  LIBRARIES 
  	${PROJECT_NAME}
	"${NS3_LIBS}"
	dccomms_utils
	dccomms_packets
	dccomms
	cpputils
	cpplogging
	dccomms_class_loader
  CATKIN_DEPENDS
        roscpp
        rospy
        std_msgs
        actionlib_msgs
        message_runtime
        dccomms_ros_msgs
  DEPENDS 
  #  	Git
	)

####### HANDLE DEPENDENCIES ######
SET(DEPS_DIR ${MODULES_DIR})
SET(TMP0 ${CMAKE_CURRENT_SOURCE_DIR}/${DEPS_DIR})
GETPROJECTS(DEPS ${TMP0})
message(STATUS "Dependencies found in ${TMP0}: ${DEPS}")
FOREACH(subdir ${DEPS})
if(GIT_FOUND)
  SET(SUBPROJECT_PATH ${DEPS_DIR}/${subdir})
  SET(SUBPROJECT_FULL_PATH ${CMAKE_CURRENT_SOURCE_DIR}/${SUBPROJECT_PATH})
  execute_process(
    COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
    WORKING_DIRECTORY ${SUBPROJECT_FULL_PATH}
    OUTPUT_VARIABLE _sub_build_version
    ERROR_QUIET
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
  SET(SUBPROJECT_GIT_NAME ${subdir}_${_sub_build_version})
  message(STATUS "Subproject generated git name: " ${SUBPROJECT_GIT_NAME})
  if (TARGET ${subdir})
      message(WARNING "Subproject ${SUBPROJECT_GIT_NAME} (${subdir}) has already been built!")
  else()
      add_subdirectory(${SUBPROJECT_PATH})
  endif()
else()
  message(STATUS "GIT not found")
endif()
ENDFOREACH()


SET(${PROJECT_NAME}_CXX_COMPILE_FLAGS "-fPIC -std=c++14 ")
SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${${PROJECT_NAME}_CXX_COMPILE_FLAGS}")


SET(${PROJECT_NAME}_CPP_FILES
        src/simulator/ROSCommsDevice.cpp
        src/simulator/ROSCommsSimulator.cpp
        src/simulator/AcousticROSCommsDevice.cpp
        src/simulator/CustomROSCommsDevice.cpp
        src/simulator/AcousticCommsChannel.cpp
        src/simulator/CustomCommsChannel.cpp
        src/simulator/PacketBuilderLoader.cpp
        src/simulator/NetsimPacket.cpp
        src/simulator/CommsChannel.cpp
        src/simulator/NetsimLogFormatter.cpp
        src/simulator/NetsimTime.cpp
        src/simulator/NetsimDevice.cpp
        src/simulator/NetsimPhy.cpp
        src/simulator/NetsimRouting.cpp
)

#https://answers.ros.org/question/97606/export-a-prebuilt-library-in-catkin/
#https://github.com/ros-drivers/prosilica_gige_sdk/blob/hydro-devel/CMakeLists.txt

FOREACH(lib ${NS3_LIBS})
	set(ns3target ${lib})
	message(STATUS "############# NS3 LIBRARY ${NS3LIB_${lib}} ----> ${ns3target}")
	add_library(${ns3target} EXCLUDE_FROM_ALL ${NS3LIB_${lib}})
	#add_custom_command(TARGET ${ns3target} POST_BUILD COMMAND cp ${NS3LIB_${lib}} ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/ )

	add_custom_command(TARGET ${ns3target} POST_BUILD COMMAND bash "${CMAKE_CURRENT_SOURCE_DIR}/ns3-postbuild.sh" ${NS3LIB_${lib}} ${CMAKE_LIBRARY_OUTPUT_DIRECTORY})

	set_target_properties(${ns3target} PROPERTIES LINKER_LANGUAGE CXX )
	install(
		FILES ${NS3LIB_${lib}}
   		DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
	)
ENDFOREACH()


add_library(${PROJECT_NAME} SHARED ${${PROJECT_NAME}_CPP_FILES})
target_include_directories(${PROJECT_NAME} PUBLIC ${${PROJECT_NAME}_INCLUDE_DIRS} ${catkin_INCLUDE_DIRS})
target_link_libraries(${PROJECT_NAME} PUBLIC ${NS3_LIBS} ${DCCOMMS_UTILS_GIT} ${catkin_LIBRARIES})
add_dependencies(${PROJECT_NAME} dccomms_ros_msgs_generate_messages_cpp)

###############################################
############ END netsim BUILD #################
###############################################

set(EXPRTK_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/modules/exprtk/exprtk.hpp)

install(DIRECTORY 
  src/include/${PROJECT_NAME}
  ${NS3_HEADERS_DIR}
  DESTINATION ${CATKIN_GLOBAL_INCLUDE_DESTINATION}
)
install(FILES
  ${EXPRTK_HEADERS}
  DESTINATION ${CATKIN_GLOBAL_INCLUDE_DESTINATION}
)
#install(FILES
# ${ns3liblist}
# DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
#)

install(TARGETS ${PROJECT_NAME}

=== modules/dccomms_utils/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.5.1)

set(CMAKE_VERBOSE_MAKEFILE ON)
set(CMAKE_COLOR_MAKEFILE   ON)
#It seams that from Ubuntu 17.10 the linker flag --disable-new-dtags is needed
#for the executable to be able to find absolute linked shared libraries with rpath.
#https://stackoverflow.com/questions/47117443/dynamic-linking-with-rpath-not-working-under-ubuntu-17-10
SET(CMAKE_EXE_LINKER_FLAGS "-Wl,--disable-new-dtags")

#SET PROJECT NAME
SET(PROJECT_NAME_ORIG "dccomms_utils" )

#SET DEPENDENCIES DIRECTORY
SET(MODULES_DIR "modules" )

SET(PROJECT_NAME_BASE ${PROJECT_NAME_ORIG} )

message("Building ${PROJECT_NAME_BASE}...")
if(DEFINED ${PROJECT_NAME_BASE}_NAME_OVERRIDE)
    SET(PROJECT_NAME_BASE ${${PROJECT_NAME_BASE}_NAME_OVERRIDE})
endif()

if(DISABLE_GIT_HASH)
	message(STATUS "PROJECT ${PROJECT_NAME_BASE}: DISABLE GIT HASH")
	SET(PROJECT_NAME_GIT "${PROJECT_NAME_BASE}")
else()
	message(STATUS "PROJECT ${PROJECT_NAME_BASE}: GIT HASH ENABLED")
	#BEGIN RESOLVE GIT REVISION
	#https://bravenewmethod.com/2017/07/14/git-revision-as-compiler-definition-in-build-with-cmake/
	message(STATUS "Resolving GIT Version...")
	set(_build_version "unknown")
	find_package(Git)
	if(GIT_FOUND)
	  execute_process(
	    COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
	    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
	    OUTPUT_VARIABLE _build_version
	    ERROR_QUIET
	    OUTPUT_STRIP_TRAILING_WHITESPACE
	  )
	  message( STATUS "GIT hash: ${_build_version}")
	else()
	  message(STATUS "GIT not found")
	endif()
	string(TIMESTAMP _time_stamp)
	#END RESOLVE GIT REVISION

	SET(PROJECT_NAME_GIT "${PROJECT_NAME_BASE}_${_build_version}")
endif()

#DECLARE PROJECT
string(TOUPPER ${PROJECT_NAME_ORIG} TMP0)
SET(${TMP0}_GIT "${PROJECT_NAME_GIT}" PARENT_SCOPE)
if (TARGET ${PROJECT_NAME_GIT})
    message(WARNING "${PROJECT_NAME_GIT} has already been built!")
    return()
endif()

project (${PROJECT_NAME_GIT} CXX)

message(STATUS "PROJECT NAME: ${PROJECT_NAME}")

##################################
####### BUILD DEPENDENCIES #######
##################################
	
#http://stackoverflow.com/questions/7787823/cmake-how-to-get-the-name-of-all-subdirectories-of-a-directory
function(GETPROJECTS result curdir)
  FILE(GLOB children RELATIVE ${curdir} ${curdir}/*/CMakeLists.txt)
  SET(dirlist "")
  FOREACH(file ${children})
        get_filename_component(subdir ${file} DIRECTORY)
        LIST(APPEND dirlist ${subdir})
  ENDFOREACH()
  SET(${result} ${dirlist} PARENT_SCOPE)
endfunction()

SET(DEPS_DIR ${MODULES_DIR})
SET(TMP0 ${CMAKE_CURRENT_SOURCE_DIR}/${DEPS_DIR})
GETPROJECTS(DEPS ${TMP0})
message(STATUS "Dependencies found in ${TMP0}: ${DEPS}")
FOREACH(subdir ${DEPS})
if(GIT_FOUND)
  SET(SUBPROJECT_PATH ${DEPS_DIR}/${subdir})
  SET(SUBPROJECT_FULL_PATH ${CMAKE_CURRENT_SOURCE_DIR}/${SUBPROJECT_PATH})
  execute_process(
    COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
    WORKING_DIRECTORY ${SUBPROJECT_FULL_PATH}
    OUTPUT_VARIABLE _sub_build_version
    ERROR_QUIET
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
  SET(SUBPROJECT_GIT_NAME ${subdir}_${_sub_build_version})
  message(STATUS "Subproject generated git name: " ${SUBPROJECT_GIT_NAME})
  if (TARGET ${subdir})
      message(WARNING "Subproject ${SUBPROJECT_GIT_NAME} (${subdir}) has already been built!")
  else()
      add_subdirectory(${SUBPROJECT_PATH})
  endif()
else()
  message(STATUS "GIT not found")
endif()
ENDFOREACH()

##################################
######### BUILD PROJECT ##########
##################################


## Add support for C++11, supported in ROS Kinetic and newer
add_definitions(-std=c++11)

## Specify additional locations of header files
## Your package locations should be listed before other locations
# include_directories(include)


######
SET(SRCPATH src/)
SET(${PROJECT_NAME}_INCLUDE_DIRS
    ${CMAKE_CURRENT_SOURCE_DIR}/${SRCPATH}lib/include
    ${${DCCOMMS_PACKETS_GIT}_INCLUDE_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/${MODULES_DIR}/cxxopts/include
    )
SET(${PROJECT_NAME}_CPP_FILES
                        ${SRCPATH}lib/USBLStream.cpp
                        ${SRCPATH}lib/GironaStream.cpp
                        ${SRCPATH}lib/EvologicsBridge.cpp
                        ${SRCPATH}lib/EvologicsStream.cpp
                        ${SRCPATH}lib/WFSStream.cpp
                        ${SRCPATH}lib/S100Stream.cpp
	)
SET(${PROJECT_NAME}_CXX_COMPILE_FLAGS "-fPIC -std=c++0x")
SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${${PROJECT_NAME}_CXX_COMPILE_FLAGS}")

include_directories(${PROJECT_NAME}_INCLUDE_DIRS)

SET(PROJECT_LIBRARIES  ${${DCCOMMS_PACKETS_GIT}_LIBRARIES})
add_library(${PROJECT_NAME} SHARED ${${PROJECT_NAME}_CPP_FILES})
target_include_directories(${PROJECT_NAME} PUBLIC ${${PROJECT_NAME}_INCLUDE_DIRS})
target_link_libraries(${PROJECT_NAME} ${PROJECT_LIBRARIES} ${catkin_LIBRARIES})

add_executable(dccomms_girona_bridge ${SRCPATH}main/dccomms_girona_bridge/dccomms_girona_bridge.cpp)
target_link_libraries(dccomms_girona_bridge ${PROJECT_NAME})

add_executable(dccomms_usbl_bridge ${SRCPATH}main/dccomms_usbl_bridge/dccomms_usbl_bridge.cpp)
target_link_libraries(dccomms_usbl_bridge ${PROJECT_NAME})

add_executable(dccomms_s100_bridge ${SRCPATH}main/dccomms_s100_bridge/dccomms_s100_bridge.cpp)
target_link_libraries(dccomms_s100_bridge ${PROJECT_NAME} cxxopts)

add_executable(dccomms_serialp_bridge ${SRCPATH}main/dccomms_serialp_bridge/dccomms_serialp_bridge.cpp)
target_link_libraries(dccomms_serialp_bridge ${PROJECT_NAME} cxxopts)

install(TARGETS ${PROJECT_NAME} dccomms_girona_bridge dccomms_usbl_bridge dccomms_s100_bridge
        LIBRARY DESTINATION "lib"
        RUNTIME DESTINATION "bin"
        )
install(DIRECTORY "src/lib/include/dccomms_utils" DESTINATION "include")
SET(${PROJECT_NAME}_INCLUDE_DIRS ${${PROJECT_NAME}_INCLUDE_DIRS} CACHE STRING "${PROJECT_NAME} include dirs")
SET(${PROJECT_NAME}_LIBRARIES ${PROJECT_NAME} ${PROJECT_LIBRARIES} CACHE STRING "${PROJECT_NAME} libraries")
message("End ${PROJECT_NAME_ORIG}")

=== modules/dccomms_utils/modules/dccomms_packets/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.5.1)

set(CMAKE_VERBOSE_MAKEFILE ON)
set(CMAKE_COLOR_MAKEFILE   ON)
#It seams that from Ubuntu 17.10 the linker flag --disable-new-dtags is needed
#for the executable to be able to find absolute linked shared libraries with rpath.
#https://stackoverflow.com/questions/47117443/dynamic-linking-with-rpath-not-working-under-ubuntu-17-10
SET(CMAKE_EXE_LINKER_FLAGS "-Wl,--disable-new-dtags")

#SET PROJECT NAME
#NOTE: replace "foo" by your project name
SET(PROJECT_NAME_ORIG "dccomms_packets" )

#SET DEPENDENCIES DIRECTORY
#NOTE: replace "gitsubmodules" by the directory name where your
#      cmake based git submodules are"
SET(MODULES_DIR "modules" )

SET(PROJECT_NAME_BASE ${PROJECT_NAME_ORIG} )

message("Building ${PROJECT_NAME_BASE}...")
if(DEFINED ${PROJECT_NAME_BASE}_NAME_OVERRIDE)
    SET(PROJECT_NAME_BASE ${${PROJECT_NAME_BASE}_NAME_OVERRIDE})
endif()

if(DISABLE_GIT_HASH)
	message(STATUS "PROJECT ${PROJECT_NAME_BASE}: DISABLE GIT HASH")
	SET(PROJECT_NAME_GIT "${PROJECT_NAME_BASE}")
else()
	message(STATUS "PROJECT ${PROJECT_NAME_BASE}: GIT HASH ENABLED")
	#BEGIN RESOLVE GIT REVISION
	#https://bravenewmethod.com/2017/07/14/git-revision-as-compiler-definition-in-build-with-cmake/
	message(STATUS "Resolving GIT Version...")
	set(_build_version "unknown")
	find_package(Git)
	if(GIT_FOUND)
	  execute_process(
	    COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
	    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
	    OUTPUT_VARIABLE _build_version
	    ERROR_QUIET
	    OUTPUT_STRIP_TRAILING_WHITESPACE
	  )
	  message( STATUS "GIT hash: ${_build_version}")
	else()
	  message(STATUS "GIT not found")
	endif()
	string(TIMESTAMP _time_stamp)
	#END RESOLVE GIT REVISION

	SET(PROJECT_NAME_GIT "${PROJECT_NAME_BASE}_${_build_version}")
endif()

#DECLARE PROJECT
string(TOUPPER ${PROJECT_NAME_ORIG} TMP0)
SET(${TMP0}_GIT "${PROJECT_NAME_GIT}" PARENT_SCOPE)
if (TARGET ${PROJECT_NAME_GIT})
    message(WARNING "${PROJECT_NAME_GIT} has already been built!")
    return()
endif()

project (${PROJECT_NAME_GIT} CXX)

message(STATUS "PROJECT NAME: ${PROJECT_NAME}")

##################################
####### BUILD DEPENDENCIES #######
##################################

#http://stackoverflow.com/questions/7787823/cmake-how-to-get-the-name-of-all-subdirectories-of-a-directory
function(GETPROJECTS result curdir)
  FILE(GLOB children RELATIVE ${curdir} ${curdir}/*/CMakeLists.txt)
  SET(dirlist "")
  FOREACH(file ${children})
        get_filename_component(subdir ${file} DIRECTORY)
        LIST(APPEND dirlist ${subdir})
  ENDFOREACH()
  SET(${result} ${dirlist} PARENT_SCOPE)
endfunction()

### EXAMPLE:
#./gitsubmodules: (NOTE: IF SET(MODULES_DIR "gitsubmodules" )))
#  module0/
#    .git
#    CMakeLists.txt:
#          ...
#          SET(PROJECT_NAME_ORIG "dep0" )
#          ...
#    ...
#  module1/
#    .git
#    CMakeLists.txt:
#           ...
#           SET(PROJECT_NAME_ORIG "dep1" )
#           ...
#    ...

SET(DEPS_DIR ${MODULES_DIR})
SET(TMP0 ${CMAKE_CURRENT_SOURCE_DIR}/${DEPS_DIR})
GETPROJECTS(DEPS ${TMP0})
message(STATUS "Dependencies found in ${TMP0}: ${DEPS}")
FOREACH(subdir ${DEPS})
if(GIT_FOUND)
  SET(SUBPROJECT_PATH ${DEPS_DIR}/${subdir})
  SET(SUBPROJECT_FULL_PATH ${CMAKE_CURRENT_SOURCE_DIR}/${SUBPROJECT_PATH})
  execute_process(
    COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
    WORKING_DIRECTORY ${SUBPROJECT_FULL_PATH}
    OUTPUT_VARIABLE _sub_build_version
    ERROR_QUIET
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
  SET(SUBPROJECT_GIT_NAME ${subdir}_${_sub_build_version})
  message(STATUS "Subproject generated git name: " ${SUBPROJECT_GIT_NAME})
  if (TARGET ${subdir})
      message(WARNING "Subproject ${SUBPROJECT_GIT_NAME} (${subdir}) has already been built!")
  else()
      add_subdirectory(${SUBPROJECT_PATH})
  endif()
else()
  message(STATUS "GIT not found")
endif()
ENDFOREACH()

##################################
######### BUILD PROJECT ##########
##################################

## Add support for C++11, supported in ROS Kinetic and newer
add_definitions(-fPIC -std=c++11)

SET(SRCPATH src/)
SET(${PROJECT_NAME}_INCLUDE_DIRS
    ${CMAKE_CURRENT_SOURCE_DIR}/${SRCPATH}include
    ${${DCCOMMS_GIT}_INCLUDE_DIRS}
)

include_directories(
  ${${PROJECT_NAME}_INCLUDE_DIRS}
)

SET(${PROJECT_NAME}_CPP_FILES
                        ${SRCPATH}SimplePacket.cpp
                        ${SRCPATH}ExternalPacketsExporter.cpp
                        ${SRCPATH}VariableLengthPacket.cpp
                        ${SRCPATH}VariableLength2BPacket.cpp
                        )

SET(PROJECT_LIBRARIES ${${DCCOMMS_GIT}_LIBRARIES})
add_library(${PROJECT_NAME} SHARED ${${PROJECT_NAME}_CPP_FILES})
target_link_libraries(${PROJECT_NAME} ${PROJECT_LIBRARIES})
target_include_directories(${PROJECT_NAME} PUBLIC ${${PROJECT_NAME}_INCLUDE_DIRS})

SET(${PROJECT_NAME}_INCLUDE_DIRS ${${PROJECT_NAME}_INCLUDE_DIRS} CACHE STRING "${PROJECT_NAME} include dirs")
SET(${PROJECT_NAME}_LIBRARIES ${PROJECT_NAME} ${PROJECT_LIBRARIES} CACHE STRING "${PROJECT_NAME} libraries")

install(TARGETS ${PROJECT_NAME}
        LIBRARY DESTINATION "lib"
        RUNTIME DESTINATION "bin"
        )
install(DIRECTORY "${SRCPATH}include/${PROJECT_NAME_ORIG}" DESTINATION "include")

message("End ${PROJECT_NAME_ORIG}")

=== modules/ns-3-dev/src/aqua-sim-ng/wscript ===
# -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-

def options(opt):
     pass

def configure(conf):
     conf.check_nonfatal(header_name='stdint.h', define_name='HAVE_STDINT_H')

def build(bld):
    module = bld.create_ns3_module('aqua-sim-ng', ['network', 'energy', 'mobility', 'internet'])
    module.source = [
        'model/aqua-sim-address.cc',
        'model/aqua-sim-pt-tag.cc',
        'model/aqua-sim-channel.cc',
        'model/aqua-sim-energy-model.cc',
        'model/aqua-sim-hash-table.cc',
        'model/aqua-sim-header.cc',
        'model/aqua-sim-header-goal.cc',
        'model/aqua-sim-header-mac.cc',
        'model/aqua-sim-mac.cc',
        'model/aqua-sim-mobility-pattern.cc',
        'model/aqua-sim-modulation.cc',
        'model/aqua-sim-net-device.cc',
        'model/aqua-sim-node.cc',
        'model/aqua-sim-noise-generator.cc',
        'model/aqua-sim-phy.cc',
        'model/aqua-sim-phy-cmn.cc',
        'model/aqua-sim-propagation.cc',
        'model/aqua-sim-range-propagation.cc',
        'model/aqua-sim-simple-propagation.cc',
        'model/aqua-sim-routing.cc',
        'model/aqua-sim-signal-cache.cc',
       # 'model/aqua-sim-sink.cc',
        'model/aqua-sim-sinr-checker.cc',
        'helper/aqua-sim-helper.cc',
        'model/aqua-sim-mac-broadcast.cc',
        'model/aqua-sim-mac-fama.cc',
        'model/aqua-sim-mac-aloha.cc',
        'model/aqua-sim-mac-copemac.cc',
        'model/aqua-sim-mac-goal.cc',
        'model/aqua-sim-mac-sfama.cc',
        'model/aqua-sim-mac-uwan.cc',
        'model/aqua-sim-rmac.cc',
        'model/aqua-sim-rmac-buffer.cc',
        'model/aqua-sim-tmac.cc',
        'model/aqua-sim-routing-static.cc',
        'model/aqua-sim-header-routing.cc',
        'model/aqua-sim-routing-dynamic.cc',
        'model/aqua-sim-routing-flooding.cc',
        'model/aqua-sim-routing-buffer.cc',
        'model/aqua-sim-routing-vbf.cc',
        'model/aqua-sim-routing-dbr.cc',
        'model/aqua-sim-routing-vbva.cc',
        'model/aqua-sim-mobility-kinematic.cc',
        'model/aqua-sim-mobility-rwp.cc',
        'model/aqua-sim-synchronization.cc',
        'model/aqua-sim-localization.cc',
        'model/aqua-sim-routing-ddos.cc',
        'model/aqua-sim-attack-model.cc',
        'model/aqua-sim-trace-reader.cc',
        'model/ndn/named-data.cc',
        'model/ndn/named-data-header.cc',
        'model/ndn/name-discovery.cc',
        'model/ndn/pit.cc',
        'model/ndn/fib.cc',
        'model/ndn/content-storage.cc',
        'model/ndn/cs-fifo.cc',
        'model/ndn/cs-lru.cc',
        'model/ndn/cs-random.cc',
        'model/ndn/onoff-nd-application.cc',
        'helper/named-data-helper.cc',
        'helper/on-off-nd-helper.cc',
        'helper/aqua-sim-traffic-gen-helper.cc',
        'model/aqua-sim-traffic-gen.cc',
        'model/aqua-sim-routing-dummy.cc',
        'model/aqua-sim-routing-ddbr.cc',
        'model/lib/svm.cpp',
        ]

    module_test = bld.create_ns3_module_test_library('aqua-sim-ng')
    module_test.source = [
        # 'test/aqua-sim-test-suite.cc',
        ]

    headers = bld(features='ns3header')
    headers.module = 'aqua-sim-ng'
    headers.source = [
        'model/aqua-sim-address.h',
        'model/aqua-sim-pt-tag.h',
        'model/aqua-sim-channel.h',
        'model/aqua-sim-energy-model.h',
        'model/aqua-sim-hash-table.h',
        'model/aqua-sim-header.h',
        'model/aqua-sim-header-goal.h',
        'model/aqua-sim-header-mac.h',
        'model/aqua-sim-mac.h',
        'model/aqua-sim-mobility-pattern.h',
        'model/aqua-sim-modulation.h',
        'model/aqua-sim-net-device.h',
        'model/aqua-sim-node.h',
        'model/aqua-sim-noise-generator.h',
        'model/aqua-sim-phy.h',
        'model/aqua-sim-phy-cmn.h',
        'model/aqua-sim-propagation.h',
        'model/aqua-sim-range-propagation.h',
        'model/aqua-sim-simple-propagation.h',
        'model/aqua-sim-routing.h',
        'model/aqua-sim-signal-cache.h',
       # 'model/aqua-sim-sink.h',
        'model/aqua-sim-sinr-checker.h',
        'helper/aqua-sim-helper.h',
        'model/aqua-sim-mac-broadcast.h',
        'model/aqua-sim-mac-fama.h',
        'model/aqua-sim-mac-aloha.h',
        'model/aqua-sim-mac-copemac.h',
        'model/aqua-sim-mac-goal.h',
        'model/aqua-sim-mac-sfama.h',
        'model/aqua-sim-mac-uwan.h',
        'model/aqua-sim-rmac.h',
        'model/aqua-sim-rmac-buffer.h',
        'model/aqua-sim-tmac.h',
        'model/aqua-sim-routing-static.h',
        'model/aqua-sim-header-routing.h',
        'model/aqua-sim-routing-dynamic.h',
        'model/aqua-sim-routing-flooding.h',
        'model/aqua-sim-datastructure.h',
        'model/aqua-sim-routing-buffer.h',
        'model/aqua-sim-routing-vbf.h',
        'model/aqua-sim-routing-dbr.h',
        'model/aqua-sim-routing-vbva.h',
        'model/aqua-sim-mobility-kinematic.h',
        'model/aqua-sim-mobility-rwp.h',
        'model/aqua-sim-synchronization.h',
        'model/aqua-sim-localization.h',
        'model/aqua-sim-routing-ddos.h',
        'model/aqua-sim-attack-model.h',
        'model/aqua-sim-trace-reader.h',
        'model/ndn/named-data.h',
        'model/ndn/named-data-header.h',
        'model/ndn/name-discovery.h',
        'model/ndn/pit.h',
        'model/ndn/fib.h',
        'model/ndn/content-storage.h',
        'model/ndn/cs-fifo.h',
        'model/ndn/cs-lru.h',
        'model/ndn/cs-random.h',
        'model/ndn/onoff-nd-application.h',
        'helper/named-data-helper.h',
        'helper/on-off-nd-helper.h',
        'helper/aqua-sim-traffic-gen-helper.h',
        'model/aqua-sim-traffic-gen.h',
        'model/aqua-sim-routing-dummy.h',
        'model/aqua-sim-routing-ddbr.h',
        'model/lib/svm.h',
        ]

    if bld.env.ENABLE_EXAMPLES:
        bld.recurse('examples')

    bld.ns3_python_bindings()

=== modules/ns-3-dev/src/aqua-sim-ng/examples/wscript ===
# -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-

def build(bld):
    obj = bld.create_ns3_program('broadcastMAC_example', ['network', 'mobility', 'energy', 'applications', 'aqua-sim-ng'])
    obj.source = 'broadcastMAC_example.cc'

    obj = bld.create_ns3_program('floodtest', ['network', 'mobility', 'energy', 'applications', 'aqua-sim-ng'])
    obj.source = 'floodtest.cc'

    obj = bld.create_ns3_program('GOAL_string', ['network', 'mobility', 'energy', 'applications', 'aqua-sim-ng'])
    obj.source = 'GOAL_string.cc'

    obj = bld.create_ns3_program('ddos', ['network', 'mobility', 'energy', 'applications', 'aqua-sim-ng'])
    obj.source = 'ddos.cc'

    obj = bld.create_ns3_program('bMAC', ['netanim', 'network', 'mobility', 'energy', 'applications', 'aqua-sim-ng'])
    obj.source = 'bMAC.cc'

    obj = bld.create_ns3_program('ND_example', ['network', 'mobility', 'energy', 'applications', 'aqua-sim-ng'])
    obj.source = 'named_data_example.cc'

    obj = bld.create_ns3_program('VBF', ['network', 'mobility', 'energy', 'applications', 'aqua-sim-ng'])
    obj.source = 'VBF.cc'

    obj = bld.create_ns3_program('FloodingMac', ['network', 'mobility', 'energy', 'applications', 'aqua-sim-ng'])
    obj.source = 'floodMac.cc'

=== modules/dccomms_utils/modules/dccomms_packets/modules/dccomms/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.5.1)

set(CMAKE_VERBOSE_MAKEFILE ON)
set(CMAKE_COLOR_MAKEFILE   ON)
#It seams that from Ubuntu 17.10 the linker flag --disable-new-dtags is needed
#for the executable to be able to find absolute linked shared libraries with rpath.
#https://stackoverflow.com/questions/47117443/dynamic-linking-with-rpath-not-working-under-ubuntu-17-10
SET(CMAKE_EXE_LINKER_FLAGS "-Wl,--disable-new-dtags")

#SET PROJECT NAME
SET(PROJECT_NAME_ORIG "dccomms" )

#SET DEPENDENCIES DIRECTORY
SET(MODULES_DIR "deps" )
 
SET(PROJECT_NAME_ORIG dccomms)

SET(PROJECT_NAME_BASE ${PROJECT_NAME_ORIG} )

message("Building ${PROJECT_NAME_BASE}...")
if(DEFINED ${PROJECT_NAME_BASE}_NAME_OVERRIDE)
    SET(PROJECT_NAME_BASE ${${PROJECT_NAME_BASE}_NAME_OVERRIDE})
endif()

if(DISABLE_GIT_HASH)
	message(STATUS "PROJECT ${PROJECT_NAME_BASE}: DISABLE GIT HASH")
	SET(PROJECT_NAME_GIT "${PROJECT_NAME_BASE}")
else()
	message(STATUS "PROJECT ${PROJECT_NAME_BASE}: GIT HASH ENABLED")
	#BEGIN RESOLVE GIT REVISION
	#https://bravenewmethod.com/2017/07/14/git-revision-as-compiler-definition-in-build-with-cmake/
	message(STATUS "Resolving GIT Version...")
	set(_build_version "unknown")
	find_package(Git)
	if(GIT_FOUND)
	  execute_process(
	    COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
	    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
	    OUTPUT_VARIABLE _build_version
	    ERROR_QUIET
	    OUTPUT_STRIP_TRAILING_WHITESPACE
	  )
	  message( STATUS "GIT hash: ${_build_version}")
	else()
	  message(STATUS "GIT not found")
	endif()
	string(TIMESTAMP _time_stamp)
	#END RESOLVE GIT REVISION

	SET(PROJECT_NAME_GIT "${PROJECT_NAME_BASE}_${_build_version}")
endif()

#DECLARE PROJECT
string(TOUPPER ${PROJECT_NAME_ORIG} TMP0)
SET(${TMP0}_GIT "${PROJECT_NAME_GIT}" PARENT_SCOPE)
if (TARGET ${PROJECT_NAME_GIT})
    message(WARNING "${PROJECT_NAME_GIT} has already been built!")
    return()
endif()

project (${PROJECT_NAME_GIT} CXX)

message(STATUS "PROJECT NAME: ${PROJECT_NAME}")

##################################
####### BUILD DEPENDENCIES #######
##################################

#http://stackoverflow.com/questions/7787823/cmake-how-to-get-the-name-of-all-subdirectories-of-a-directory
function(GETPROJECTS result curdir)
  FILE(GLOB children RELATIVE ${curdir} ${curdir}/*/CMakeLists.txt)
  SET(dirlist "")
  FOREACH(file ${children})
        get_filename_component(subdir ${file} DIRECTORY)
        LIST(APPEND dirlist ${subdir})
  ENDFOREACH()
  SET(${result} ${dirlist} PARENT_SCOPE)
endfunction()

SET(DEPS_DIR ${MODULES_DIR})
SET(TMP0 ${CMAKE_CURRENT_SOURCE_DIR}/${DEPS_DIR})
GETPROJECTS(DEPS ${TMP0})
message(STATUS "Dependencies found in ${TMP0}: ${DEPS}")
FOREACH(subdir ${DEPS})
if(GIT_FOUND)
  SET(SUBPROJECT_PATH ${DEPS_DIR}/${subdir})
  SET(SUBPROJECT_FULL_PATH ${CMAKE_CURRENT_SOURCE_DIR}/${SUBPROJECT_PATH})
  execute_process(
    COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
    WORKING_DIRECTORY ${SUBPROJECT_FULL_PATH}
    OUTPUT_VARIABLE _sub_build_version
    ERROR_QUIET
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
  SET(SUBPROJECT_GIT_NAME ${subdir}_${_sub_build_version})
  message(STATUS "Subproject generated git name: " ${SUBPROJECT_GIT_NAME})
  if (TARGET ${subdir})
      message(WARNING "Subproject ${SUBPROJECT_GIT_NAME} (${subdir}) has already been built!")
  else()
      add_subdirectory(${SUBPROJECT_PATH})
  endif()
else()
  message(STATUS "GIT not found")
endif()
ENDFOREACH()

###### 

SET(${PROJECT_NAME}_INCLUDE_DIRS
    ${CMAKE_CURRENT_SOURCE_DIR}/include
    ${${CPPLOGGING_GIT}_INCLUDE_DIRS}
    ${${CLASS_LOADER_GIT}_INCLUDE_DIRS}
    ${${CPPUTILS_GIT}_INCLUDE_DIRS}
   )

SET(SRCPATH src/)
file(GLOB ${PROJECT_NAME}_CPP_FILES
    ${SRCPATH}Arduino.cpp
    ${SRCPATH}BlockRadioTransmitter.cpp
    ${SRCPATH}Checksum.cpp
    ${SRCPATH}CommsBridge.cpp
    ${SRCPATH}CommsDeviceService.cpp
    ${SRCPATH}CommsException.cpp
    ${SRCPATH}DataLinkFrame.cpp
    ${SRCPATH}CommsDevice.cpp
    ${SRCPATH}Stream.cpp
    ${SRCPATH}StreamCommsDevice.cpp
    ${SRCPATH}NamedPipeStream.cpp
    ${SRCPATH}Packet.cpp
    ${SRCPATH}Radio.cpp
    ${SRCPATH}SerialPortStream.cpp
    ${SRCPATH}TCPStream.cpp
    ${SRCPATH}Utils.cpp
    ${SRCPATH}CommsDeviceSocket.cpp
    )

SET(PROJECT_LIBRARIES m pthread rt crypto ${CPPLOGGING_GIT} ${${CLASS_LOADER_GIT}_LIBRARIES} ${CPPUTILS_GIT})

SET(${PROJECT_NAME}_CXX_COMPILE_FLAGS "-fPIC -std=c++14")
SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${${PROJECT_NAME}_CXX_COMPILE_FLAGS}")

add_library(${PROJECT_NAME} SHARED ${${PROJECT_NAME}_CPP_FILES})
target_include_directories(${PROJECT_NAME} PUBLIC ${${PROJECT_NAME}_INCLUDE_DIRS})
target_link_libraries(${PROJECT_NAME} ${PROJECT_LIBRARIES})

install(TARGETS ${PROJECT_NAME}
	LIBRARY DESTINATION "lib"
	)
install(DIRECTORY "include/dccomms" DESTINATION "include")

SET(${PROJECT_NAME}_INCLUDE_DIRS ${${PROJECT_NAME}_INCLUDE_DIRS} CACHE STRING "${PROJECT_NAME} include dirs")
SET(${PROJECT_NAME}_LIBRARIES ${PROJECT_NAME} ${PROJECT_LIBRARIES} CACHE STRING "${PROJECT_NAME} libraries")

message("End ${PROJECT_NAME_ORIG}")

=== modules/dccomms_utils/modules/dccomms_packets/modules/dccomms/deps/class_loader/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
set(CMAKE_VERBOSE_MAKEFILE ON)
#It seams that from Ubuntu 17.10 the linker flag --disable-new-dtags is needed
#for the executable to be able to find absolute linked shared libraries with rpath.
#https://stackoverflow.com/questions/47117443/dynamic-linking-with-rpath-not-working-under-ubuntu-17-10
SET(CMAKE_EXE_LINKER_FLAGS "-Wl,--disable-new-dtags")

#SET PROJECT NAME
#NOTE: replace "foo" by your project name
SET(PROJECT_NAME_ORIG "class_loader" )

SET(PROJECT_NAME_BASE ${PROJECT_NAME_ORIG} )

message("Building ${PROJECT_NAME_BASE}...")
if(DEFINED ${PROJECT_NAME_BASE}_NAME_OVERRIDE)
    SET(PROJECT_NAME_BASE ${${PROJECT_NAME_BASE}_NAME_OVERRIDE})
endif()

if(DISABLE_GIT_HASH)
	message(STATUS "PROJECT ${PROJECT_NAME_BASE}: DISABLE GIT HASH")
	SET(PROJECT_NAME_GIT "${PROJECT_NAME_BASE}")
else()
	message(STATUS "PROJECT ${PROJECT_NAME_BASE}: GIT HASH ENABLED")
	#BEGIN RESOLVE GIT REVISION
	#https://bravenewmethod.com/2017/07/14/git-revision-as-compiler-definition-in-build-with-cmake/
	message(STATUS "Resolving GIT Version...")
	set(_build_version "unknown")
	find_package(Git)
	if(GIT_FOUND)
	  execute_process(
	    COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
	    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
	    OUTPUT_VARIABLE _build_version
	    ERROR_QUIET
	    OUTPUT_STRIP_TRAILING_WHITESPACE
	  )
	  message( STATUS "GIT hash: ${_build_version}")
	else()
	  message(STATUS "GIT not found")
	endif()
	string(TIMESTAMP _time_stamp)
	#END RESOLVE GIT REVISION

	SET(PROJECT_NAME_GIT "${PROJECT_NAME_BASE}_${_build_version}")
endif()

#DECLARE PROJECT
string(TOUPPER ${PROJECT_NAME_ORIG} TMP0)
SET(${TMP0}_GIT "${PROJECT_NAME_GIT}" PARENT_SCOPE)
if (TARGET ${PROJECT_NAME_GIT})
    message(WARNING "${PROJECT_NAME_GIT} has already been built!")
    return()
endif()

project (${PROJECT_NAME_GIT} CXX)

message(STATUS "PROJECT NAME: ${PROJECT_NAME}")

find_package(Boost REQUIRED COMPONENTS thread system)
find_package(console_bridge REQUIRED)

SET(BUILDTYPE ${CMAKE_BUILD_TYPE})
SET(CMAKE_BUILD_TYPE "Release")
set(Poco_DIR cmake)
find_package(Poco REQUIRED COMPONENTS Foundation)
SET(CMAKE_BUILD_TYPE ${BUILDTYPE})
set(CATKIN_GLOBAL_BIN_DESTINATION bin)
set(CATKIN_GLOBAL_LIB_DESTINATION lib)
set(CATKIN_GLOBAL_LIBEXEC_DESTINATION lib)
set(CATKIN_GLOBAL_INCLUDE_DESTINATION include)
set(CATKIN_PACKAGE_LIB_DESTINATION ${CATKIN_GLOBAL_LIB_DESTINATION})
set(CATKIN_PACKAGE_BIN_DESTINATION ${CATKIN_GLOBAL_LIBEXEC_DESTINATION}/${PROJECT_NAME})
set(CATKIN_PACKAGE_INCLUDE_DESTINATION ${CATKIN_GLOBAL_INCLUDE_DESTINATION}/${PROJECT_NAME})

include_directories(include ${console_bridge_INCLUDE_DIRS} ${Boost_INCLUDE_DIRS} ${Poco_INCLUDE_DIRS})

set(${PROJECT_NAME}_SRCS
  src/class_loader.cpp
  src/class_loader_core.cpp
  src/meta_object.cpp
  src/multi_library_class_loader.cpp
)
set(${PROJECT_NAME}_HDRS
  include/class_loader/class_loader.h
  include/class_loader/class_loader_core.h
  include/class_loader/class_loader_exceptions.h
  include/class_loader/class_loader_register_macro.h
  include/class_loader/console_bridge_compatibility.h
  include/class_loader/meta_object.h
  include/class_loader/multi_library_class_loader.h
)
add_definitions(-fPIC)
add_library(${PROJECT_NAME} ${${PROJECT_NAME}_SRCS} ${${PROJECT_NAME}_HDRS})
target_link_libraries(${PROJECT_NAME} ${Boost_LIBRARIES} ${console_bridge_LIBRARIES} ${Poco_LIBRARIES})

install(TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION})
install(DIRECTORY include/class_loader/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION})

install(PROGRAMS scripts/class_loader_headers_update.py
  DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})

set(TARGET_NAME ${PROJECT_NAME})
set(PKGCONFIG_LIBS
${Boost_LIBRARIES}
${console_bridge_LIBRARIES}
${Poco_LIBRARIES}
)
message(STATUS "POCO LIBS: ${Poco_LIBRARIES}")
SET(${PROJECT_NAME}_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/include/ CACHE STRING "${PROJECT_NAME} include dirs")
SET(${PROJECT_NAME}_LIBRARIES ${PROJECT_NAME} CACHE STRING "${PROJECT_NAME} libraries")
# Prepare and install necessary files to support finding of the library
# using pkg-config
#configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/${TARGET_NAME}.pc.in
#  ${CMAKE_CURRENT_BINARY_DIR}/${TARGET_NAME}.pc @ONLY)
#
  #install(FILES ${CMAKE_BINARY_DIR}/${PROJECT_NAME}.pc DESTINATION lib/pkgconfig)

=== modules/dccomms_utils/modules/dccomms_packets/modules/dccomms/deps/cpplogging/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.5.1)
project (cpplogging C CXX)

set(CMAKE_VERBOSE_MAKEFILE ON)
set(CMAKE_COLOR_MAKEFILE   ON)
#It seams that from Ubuntu 17.10 the linker flag --disable-new-dtags is needed
#for the executable to be able to find absolute linked shared libraries with rpath.
#https://stackoverflow.com/questions/47117443/dynamic-linking-with-rpath-not-working-under-ubuntu-17-10
SET(CMAKE_EXE_LINKER_FLAGS "-Wl,--disable-new-dtags")

# Remove 'lib' prefix for shared libraries on Windows
if (WIN32)
  set(CMAKE_SHARED_LIBRARY_PREFIX "")
endif ()

SET(PROJECT_NAME_ORIG cpplogging)

SET(PROJECT_NAME_BASE ${PROJECT_NAME_ORIG} )

message("Building ${PROJECT_NAME_BASE}...")
if(DEFINED ${PROJECT_NAME_BASE}_NAME_OVERRIDE)
    SET(PROJECT_NAME_BASE ${${PROJECT_NAME_BASE}_NAME_OVERRIDE})
endif()

if(DISABLE_GIT_HASH)
	message(STATUS "PROJECT ${PROJECT_NAME_BASE}: DISABLE GIT HASH")
	SET(PROJECT_NAME_GIT "${PROJECT_NAME_BASE}")
else()
	message(STATUS "PROJECT ${PROJECT_NAME_BASE}: GIT HASH ENABLED")
	#BEGIN RESOLVE GIT REVISION
	#https://bravenewmethod.com/2017/07/14/git-revision-as-compiler-definition-in-build-with-cmake/
	message(STATUS "Resolving GIT Version...")
	set(_build_version "unknown")
	find_package(Git)
	if(GIT_FOUND)
	  execute_process(
	    COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
	    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
	    OUTPUT_VARIABLE _build_version
	    ERROR_QUIET
	    OUTPUT_STRIP_TRAILING_WHITESPACE
	  )
	  message( STATUS "GIT hash: ${_build_version}")
	else()
	  message(STATUS "GIT not found")
	endif()
	string(TIMESTAMP _time_stamp)
	#END RESOLVE GIT REVISION

	SET(PROJECT_NAME_GIT "${PROJECT_NAME_BASE}_${_build_version}")
endif()

#DECLARE PROJECT
string(TOUPPER ${PROJECT_NAME_ORIG} TMP0)
SET(${TMP0}_GIT "${PROJECT_NAME_GIT}" PARENT_SCOPE)
if (TARGET ${PROJECT_NAME_GIT})
    message(WARNING "${PROJECT_NAME_GIT} has already been built!")
    return()
endif()

project (${PROJECT_NAME_GIT} CXX)

message(STATUS "PROJECT NAME: ${PROJECT_NAME}")

###############################
###############################

add_library(${PROJECT_NAME} SHARED
    src/Loggable.cpp
    src/Logger.cpp
    )

SET(${PROJECT_NAME}_CXX_COMPILE_FLAGS "-fPIC -std=c++0x")
SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${${PROJECT_NAME}_CXX_COMPILE_FLAGS}")


SET(${PROJECT_NAME}_INCLUDE_DIRS
    ${CMAKE_CURRENT_SOURCE_DIR}/includes
    ${CMAKE_CURRENT_SOURCE_DIR}/spdlog/include
    )

message(STATUS "${PROJECT_NAME} include dirs: ${${PROJECT_NAME}_INCLUDE_DIRS}")

target_include_directories(${PROJECT_NAME} PUBLIC ${${PROJECT_NAME}_INCLUDE_DIRS})

target_link_libraries(${PROJECT_NAME} pthread)

#https://cmake.org/cmake/help/v3.0/command/install.html 
install(TARGETS ${PROJECT_NAME}	LIBRARY DESTINATION "lib")
install(DIRECTORY "spdlog/include/spdlog" DESTINATION "include")
install(DIRECTORY "includes/cpplogging" DESTINATION "include")

SET(${PROJECT_NAME}_INCLUDE_DIRS ${${PROJECT_NAME}_INCLUDE_DIRS} CACHE STRING "${PROJECT_NAME} include dirs")
SET(${PROJECT_NAME}_LIBRARIES ${PROJECT_NAME} CACHE STRING "${PROJECT_NAME} libraries")

message("End ${PROJECT_NAME_ORIG}")

=== modules/dccomms_utils/modules/dccomms_packets/modules/dccomms/deps/cpputils/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.5.1)

set(CMAKE_VERBOSE_MAKEFILE ON)
set(CMAKE_COLOR_MAKEFILE   ON)
#It seams that from Ubuntu 17.10 the linker flag --disable-new-dtags is needed
#for the executable to be able to find absolute linked shared libraries with rpath.
#https://stackoverflow.com/questions/47117443/dynamic-linking-with-rpath-not-working-under-ubuntu-17-10
SET(CMAKE_EXE_LINKER_FLAGS "-Wl,--disable-new-dtags")

#SET PROJECT NAME
#NOTE: replace "foo" by your project name
SET(PROJECT_NAME_ORIG "cpputils" )

#SET DEPENDENCIES DIRECTORY
#NOTE: replace "gitsubmodules" by the directory name where your
#      cmake based git submodules are"
SET(MODULES_DIR "modules" )

SET(PROJECT_NAME_BASE ${PROJECT_NAME_ORIG} )

message("Building ${PROJECT_NAME_BASE}...")
if(DEFINED ${PROJECT_NAME_BASE}_NAME_OVERRIDE)
    SET(PROJECT_NAME_BASE ${${PROJECT_NAME_BASE}_NAME_OVERRIDE})
endif()

if(DISABLE_GIT_HASH)
	message(STATUS "PROJECT ${PROJECT_NAME_BASE}: DISABLE GIT HASH")
	SET(PROJECT_NAME_GIT "${PROJECT_NAME_BASE}")
else()
	message(STATUS "PROJECT ${PROJECT_NAME_BASE}: GIT HASH ENABLED")
	#BEGIN RESOLVE GIT REVISION
	#https://bravenewmethod.com/2017/07/14/git-revision-as-compiler-definition-in-build-with-cmake/
	message(STATUS "Resolving GIT Version...")
	set(_build_version "unknown")
	find_package(Git)
	if(GIT_FOUND)
	  execute_process(
	    COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
	    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
	    OUTPUT_VARIABLE _build_version
	    ERROR_QUIET
	    OUTPUT_STRIP_TRAILING_WHITESPACE
	  )
	  message( STATUS "GIT hash: ${_build_version}")
	else()
	  message(STATUS "GIT not found")
	endif()
	string(TIMESTAMP _time_stamp)
	#END RESOLVE GIT REVISION

	SET(PROJECT_NAME_GIT "${PROJECT_NAME_BASE}_${_build_version}")
endif()

#DECLARE PROJECT
string(TOUPPER ${PROJECT_NAME_ORIG} TMP0)
SET(${TMP0}_GIT "${PROJECT_NAME_GIT}" PARENT_SCOPE)
if (TARGET ${PROJECT_NAME_GIT})
    message(WARNING "${PROJECT_NAME_GIT} has already been built!")
    return()
endif()

project (${PROJECT_NAME_GIT} CXX)

message(STATUS "PROJECT NAME: ${PROJECT_NAME}")

##################################
####### BUILD DEPENDENCIES #######
##################################

#http://stackoverflow.com/questions/7787823/cmake-how-to-get-the-name-of-all-subdirectories-of-a-directory
function(GETPROJECTS result curdir)
  FILE(GLOB children RELATIVE ${curdir} ${curdir}/*/CMakeLists.txt)
  SET(dirlist "")
  FOREACH(file ${children})
        get_filename_component(subdir ${file} DIRECTORY)
        LIST(APPEND dirlist ${subdir})
  ENDFOREACH()
  SET(${result} ${dirlist} PARENT_SCOPE)
endfunction()

### EXAMPLE:
#./gitsubmodules: (NOTE: IF SET(MODULES_DIR "gitsubmodules" )))
#  module0/
#    .git
#    CMakeLists.txt:
#          ...
#          SET(PROJECT_NAME_ORIG "dep0" )
#          ...
#    ...
#  module1/
#    .git
#    CMakeLists.txt:
#           ...
#           SET(PROJECT_NAME_ORIG "dep1" )
#           ...
#    ...

SET(DEPS_DIR ${MODULES_DIR})
SET(TMP0 ${CMAKE_CURRENT_SOURCE_DIR}/${DEPS_DIR})
GETPROJECTS(DEPS ${TMP0})
message(STATUS "Dependencies found in ${TMP0}: ${DEPS}")
FOREACH(subdir ${DEPS})
if(GIT_FOUND)
  SET(SUBPROJECT_PATH ${DEPS_DIR}/${subdir})
  SET(SUBPROJECT_FULL_PATH ${CMAKE_CURRENT_SOURCE_DIR}/${SUBPROJECT_PATH})
  execute_process(
    COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
    WORKING_DIRECTORY ${SUBPROJECT_FULL_PATH}
    OUTPUT_VARIABLE _sub_build_version
    ERROR_QUIET
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
  SET(SUBPROJECT_GIT_NAME ${subdir}_${_sub_build_version})
  message(STATUS "Subproject generated git name: " ${SUBPROJECT_GIT_NAME})
  if (TARGET ${subdir})
      message(WARNING "Subproject ${SUBPROJECT_GIT_NAME} (${subdir}) has already been built!")
  else()
      add_subdirectory(${SUBPROJECT_PATH})
  endif()
else()
  message(STATUS "GIT not found")
endif()
ENDFOREACH()

##################################
######### BUILD PROJECT ##########
##################################

## Add support for C++11, supported in ROS Kinetic and newer
add_definitions(-fPIC -std=c++11)

SET(SRCPATH src/)
SET(${PROJECT_NAME}_INCLUDE_DIRS
    ${CMAKE_CURRENT_SOURCE_DIR}/${SRCPATH}include
)

include_directories(
  ${${PROJECT_NAME}_INCLUDE_DIRS}
)

SET(${PROJECT_NAME}_CPP_FILES
                        ${SRCPATH}SignalManager.cpp
                        ${SRCPATH}Timer.cpp
                        )

add_library(${PROJECT_NAME} SHARED ${${PROJECT_NAME}_CPP_FILES})

SET(${PROJECT_NAME}_INCLUDE_DIRS ${${PROJECT_NAME}_INCLUDE_DIRS} CACHE STRING "${PROJECT_NAME} include dirs")
SET(${PROJECT_NAME}_LIBRARIES ${PROJECT_NAME} CACHE STRING "${PROJECT_NAME} libraries")

install(TARGETS ${PROJECT_NAME}
        LIBRARY DESTINATION "lib"
        RUNTIME DESTINATION "bin"
        )
install(DIRECTORY "${SRCPATH}include/${PROJECT_NAME_ORIG}" DESTINATION "include")

message("End ${PROJECT_NAME_ORIG}")

=== debian/changelog ===
ros-melodic-dccomms-ros (0.0.3-1bionic) bionic; urgency=high



 -- Diego Centelles <centelld@uji.es>  Sat, 14 Mar 2020 23:00:00 -0000

ros-melodic-dccomms-ros (0.0.2-1bionic) bionic; urgency=high



 -- Diego Centelles <centelld@uji.es>  Fri, 15 Nov 2019 23:00:00 -0000

ros-melodic-dccomms-ros (0.0.1-1bionic) bionic; urgency=high



 -- Diego Centelles <centelld@uji.es>  Sat, 09 Nov 2019 23:00:00 -0000

=== debian/control ===
Source: ros-melodic-dccomms-ros
Section: misc
Priority: extra
Maintainer: Diego Centelles <centelld@uji.es>
Build-Depends: debhelper (>= 9.0.0), git, ros-melodic-actionlib, ros-melodic-actionlib-msgs, ros-melodic-catkin, ros-melodic-dccomms-ros-msgs, ros-melodic-message-generation, ros-melodic-roscpp, ros-melodic-rospy, ros-melodic-std-msgs, ros-melodic-tf
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-dccomms-ros
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, git, ros-melodic-actionlib, ros-melodic-actionlib-msgs, ros-melodic-dccomms-ros-msgs, ros-melodic-message-runtime, ros-melodic-roscpp, ros-melodic-rospy, ros-melodic-std-msgs, ros-melodic-tf
Description: The dccomms_ros package

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-dccomms-ros//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install
